﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using System.Diagnostics;
using System.Management;
using System.Threading;
using System.Runtime.InteropServices;

namespace OfficeShadowDisabler
{
    static class Program
    {
        static string[] processesToDisableShadowsOn = { "outlook", "lync", "excel", "winword", "powerpnt", "msaccess", "mspub" };

        [DllImport("user32.dll", SetLastError = true)]
        static extern uint GetWindowThreadProcessId(IntPtr hWnd, out uint processId);

        static SystemProcessHookForm hookForm;

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            foreach (String s in processesToDisableShadowsOn)
            {
                disableShadow(s);
            }
            WatchForWindowCreation();

            MinimizeFootprint();
            Application.Run();
        }

        private static void WatchForWindowCreation()
        {
            hookForm = new SystemProcessHookForm();
            //hookForm.Show();
            hookForm.WindowEvent += (object sender, ShellHook.ShellEvents action, IntPtr hWnd, string windowTitle) =>
            {
                uint pid = 0;
                try
                {

                    GetWindowThreadProcessId(hWnd, out pid);

                    if (pid != 0)
                    {
                        Process process = Process.GetProcessById(Convert.ToInt32(pid));
                        if (processesToDisableShadowsOn.Contains(process.ProcessName.ToLower()))
                        {
                            Utilities.Display.DisableShadows(process.MainWindowHandle);
                        }
                    }
                }
                catch (Exception ex)
                {
                    Console.WriteLine(ex.Message);
                }

            };
        }
        [DllImport("psapi.dll")]
        static extern int EmptyWorkingSet(IntPtr hwProc);

        static void MinimizeFootprint()
        {
            EmptyWorkingSet(Process.GetCurrentProcess().Handle);
        }

        public static void disableShadow(String process)
        {
            Process[] processes = Process.GetProcessesByName(process);

            foreach (Process p in processes)
            {
                Utilities.Display.DisableShadows(p.MainWindowHandle);
            }
        }

    }
}
